// Import Third-party Dependencies
import { match } from "ts-pattern";
import { consolePrinter } from "../../../../../lib/console-printer/index.js";
import { Nsci } from "../../../../configuration/index.js";
export function getOutcomeEmoji(warningsMode) {
    return match(warningsMode)
        .with("error", () => "✖")
        .with("off", () => "✓")
        .with("warning", () => "⚠")
        .otherwise(() => "⚠");
}
export function printWarnOrError(warningsMode) {
    return warningsMode === Nsci.warnings.ERROR
        ? consolePrinter.font.error
        : consolePrinter.font.info;
}
export function buildOutcomeStatsConsoleMessage(statsLength, warningsMode) {
    if (statsLength > 0) {
        const outcomeEmoji = getOutcomeEmoji(warningsMode);
        const printWarnOrErr = printWarnOrError(warningsMode);
        return printWarnOrErr(`${statsLength}`)
            .prefix(printWarnOrErr(outcomeEmoji).message)
            .bold();
    }
    return consolePrinter.font
        .success(`${statsLength}`)
        .prefix(consolePrinter.font.success("✓").message)
        .bold();
}
//# sourceMappingURL=util.js.map