/// <reference types="node" />
import { Result } from "ts-results";
import { RequireAtLeastOne } from "type-fest";
import { RC, RCGenerationMode } from "../rc.js";
interface createReadOptions {
    /**
     * If enabled the file will be created if it does not exist on the disk.
     *
     * @default false
     */
    createIfDoesNotExist?: boolean;
    /**
     * RC Generation mode. This option allows to generate a more or less complete configuration for some NodeSecure tools.
     *
     * @default `minimal`
     */
    createMode?: RCGenerationMode | RCGenerationMode[];
}
export declare type readOptions = RequireAtLeastOne<createReadOptions, "createIfDoesNotExist" | "createMode">;
export declare function read(location?: string, options?: readOptions): Promise<Result<RC, NodeJS.ErrnoException>>;
export {};
